      SUBROUTINE CJCG2 (AR,AB,CR,CB,ER,EB,FR,FB,UR,UB,DUR,DUB,FACR,
     1FACB,NX,NR,NB,IT)
      INCLUDE 'TYPES.INC'

***   CJCG2 - SOLVE SYMMETRIC LINEAR SYSTEM (NR=NB+NX CASE)
*
*     S.SELBERHERR   1979-1987
*
      PARAMETER (ACCREL=1.E-2,MAXJCG=100)
      DIMENSION AR(NR),AB(NB),CR(NR),CB(NB),ER(NR),EB(NB),FR(NR),FB(NB),
     1UR(NR),UB(NB),DUR(NR),DUB(NB),FACR(NR),FACB(NB)

      K=NX
      M=NB
      N=NR
**    FACTORIZE DB AND DR
      CALL TRIFAC (EB,AB,FACB,M)
      CALL TRIFAC (ER,AR,FACR,N)

**    COMPUTE UB(0)=DB**-1*FB INTO FB
      CALL TRISOL (AB,FB,FACB,M)

**    COMPUTE DR**-1*(FR-H*UB(0)) INTO UR
      DO 7701 L=1,K
 7701 UR(L)=FR(L)-CR(L)*FB(L)
      DO 7702 L=K+1,M
 7702 UR(L)=FR(L)-CR(L)*FB(L)-CB(L-K)*FB(L-K)
      DO 7703 L=M+1,N
 7703 UR(L)=FR(L)-CB(L-K)*FB(L-K)
      CALL TRISOL (AR,UR,FACR,N)

**    COMPUTE DUB(0)=DB**-1*HT*DR**-1*(FR-H*UB(0)) INTO DUB
      DO 7704 L=1,M
      DUB(L)=CR(L)*UR(L)+CB(L)*UR(L+K)
 7704 UR(L)=DUB(L)
      CALL TRISOL (AB,DUB,FACB,M)

**    COMPUTE DUB(0)T*DB*DUB(0) INTO ALPHB
      ALPHB=DOTPRO(DUB,UR,M)
**    COMPUTE DUR(0)=-DR**-1*H*DUB(0) INTO DUR
      DO 7705 L=1,K
      DUR(L)=CR(L)*DUB(L)
 7705 UR(L)=DUR(L)
      DO 7706 L=K+1,M
      DUR(L)=CR(L)*DUB(L)+CB(L-K)*DUB(L-K)
 7706 UR(L)=DUR(L)
      DO 7707 L=M+1,N
      DUR(L)=CB(L-K)*DUB(L-K)
 7707 UR(L)=DUR(L)
      CALL TRISOL (AR,DUR,FACR,N)

**    COMPUTE DUR(0)T**DR**DUR(0) INTO ALPHR
      ALPHR=DOTPRO(DUR,UR,N)

      R=1/(1-ALPHR/ALPHB)

**    COMPUTE UB(1)=UB(0)-R*DUB(0) INTO UB
      DO 7708 L=1,M
 7708 UB(L)=FB(L)-R*DUB(L)

      IT=1

**    COMPUTE R*DB**-1*HT*DUR(IT-1) INTO ER
 1    DO 7709 L=1,M
      UR(L)=CR(L)*DUR(L)+CB(L)*DUR(L+K)
 7709 ER(L)=R*UR(L)
      CALL TRISOL (AB,ER,FACB,M)

**    COMPUTE DUB(IT)=R*DB**-1*HT*DUR(IT-1)+(1-R)*DUB(IT-1) INTO DUB
      DO 7710 L=1,M
 7710 DUB(L)=ER(L)+(1-R)*DUB(L)
**    COMPUTE DUB(IT)T*DB*DUB(IT) INTO ALPHB
      ALPHB=DOTPRO(DUB,UR,M)
      ALPHB=R*ALPHB
      RO=R
      R=1/(1-ALPHB/(ALPHR*RO))
**    COMPUTE R*DR**-1*H*DUB(IT) INTO ER
      DO 7711 L=1,K
      UR(L)=CR(L)*DUB(L)
 7711 ER(L)=R*UR(L)
      DO 7712 L=K+1,M
      UR(L)=CR(L)*DUB(L)+CB(L-K)*DUB(L-K)
 7712 ER(L)=R*UR(L)
      DO 7713 L=M+1,N
      UR(L)=CB(L-K)*DUB(L-K)
 7713 ER(L)=R*UR(L)
      CALL TRISOL (AR,ER,FACR,N)

**    COMPUTE DUR(IT)=R*DR**-1*H*DUB(IT)+(1-R)*DUR(IT-1) INTO DUR
      DO 7714 L=1,N
 7714 DUR(L)=ER(L)+(1-R)*DUR(L)
**    COMPUTE DUR(IT)T*DR*DUR(IT) INTO ALPHR
      ALPHR=R*DOTPRO(DUR,UR,N)

**    COMPUTE ITERATION PARAMETERS
      ROO=RO
      RO=R
      R=1/(1-ALPHR/(ALPHB*RO))
      IT=IT+1

**    COMPUTE UB(IT+1) INTO FB
**    COMPUTE R*DB**-1*HT*DUR(IT-1) INTO ER
      RXX=(1/RO-1)*(1/ROO-1)
      DO 7715 L=1,M
      UR(L)=CR(L)*DUR(L)+CB(L)*DUR(L+K)
      FB(L)=UB(L)-R*RO*(DUB(L)-RXX*(UB(L)-FB(L)))
 7715 ER(L)=R*UR(L)
      CALL TRISOL (AB,ER,FACB,M)

**    COMPUTE DUB(IT)=R*DB**-1*HT*DUR(IT-1)+(1-R)*DUB(IT-1) INTO DUB
      DO 7716 L=1,M
 7716 DUB(L)=ER(L)+(1-R)*DUB(L)
**    COMPUTE DUB(IT)T*DB*DUB(IT) INTO ALPHB
      ALPHB=R*DOTPRO(DUB,UR,M)
      RO=R
      R=1/(1-ALPHB/(ALPHR*RO))
**    COMPUTE R*DR**-1*H*DUB(IT) INTO ER
      DO 7717 L=1,K
      UR(L)=CR(L)*DUB(L)
 7717 ER(L)=R*UR(L)
      DO 7718 L=K+1,M
      UR(L)=CR(L)*DUB(L)+CB(L-K)*DUB(L-K)
 7718 ER(L)=R*UR(L)
      DO 7719 L=M+1,N
      UR(L)=CB(L-K)*DUB(L-K)
 7719 ER(L)=R*UR(L)
      CALL TRISOL (AR,ER,FACR,N)

**    COMPUTE DUR(IT)=R*DR**-1*H*DUB(IT)+(1-R)*DUR(IT-1) INTO DUR
      DO 7720 L=1,N
 7720 DUR(L)=ER(L)+(1-R)*DUR(L)
**    COMPUTE DUR(IT)T*DR*DUR(IT) INTO ALPHR
      ALPHR=R*DOTPRO(DUR,UR,N)

**    COMPUTE ITERATION PARAMETERS
      ROO=RO
      RO=R
      R=1/(1-ALPHR/(ALPHB*RO))

**    COMPUTE UB(IT+1) INTO UB
      RXX=(1/RO-1)*(1/ROO-1)
      DO 7721 L=1,M
 7721 UB(L)=FB(L)-R*RO*(DUB(L)-RXX*(FB(L)-UB(L)))

**    CHECK ERROR
      IF (N*DIFNRM(UB,FB,M).LE.ACCREL) GOTO 2

      IT=IT+1
      IF (IT.LT.MAXJCG) GOTO 1

**    COMPUTE UR=DR**-1*(FR-H*UB) INTO UR
 2    DO 7722 L=1,K
 7722 UR(L)=FR(L)-CR(L)*UB(L)
      DO 7723 L=K+1,M
 7723 UR(L)=FR(L)-CR(L)*UB(L)-CB(L-K)*UB(L-K)
      DO 7724 L=M+1,N
 7724 UR(L)=FR(L)-CB(L-K)*UB(L-K)
      CALL TRISOL (AR,UR,FACR,N)

      END
