      FUNCTION CUBF (DX1X,DX12,F,D)
      INCLUDE 'TYPES.INC'

***   CUBF - EVALUATE CUBIC POLYNOMIAL
*
*     S.SELBERHERR   1979-1986
*
      DIMENSION F(2),D(2)

      A1=D(1)*DX12
      A2=3*(F(2)-F(1))-2*A1-D(2)*DX12
      A3=F(2)-F(1)-A2-A1
      X=DX1X/DX12
      CUBF=F(1)+X*(A1+X*(A2+X*A3))

      END
      SUBROUTINE DOP1D (CDON,CACC,C,DCDY)
      INCLUDE 'TYPES.INC'

***   DOP1D - SETUP DOPING FROM ONE-DIMENSIONAL DATA
*
*     A.SCHUETZ      1980-1983
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      DIMENSION CDON(NXY),CACC(NXY),C(MAXDO1,6),DCDY(MAXDO1,6)

**    START OF EXECUTABLE CODE
*     ************************
*
      JY=NYOX-1
      REWIND NUMDOP
      READ (NUMDOP,END=3) DUMMY,YINC
      YINC=YINC/XYNOR

**    STANDARD MOS-DEVICE (4) OR     ASYMMETRIC OR LDD DEVICE (6)
      IF (IPROF.EQ.0) THEN
         NSTP=4
      ELSE
         NSTP=6
      ENDIF

      DO 1 I=1,MAXDO1
 1    READ (NUMDOP,END=4) (C(I,J),DCDY(I,J),J=1,NSTP)

      DO 7701 J=1,NSTP
      DO 7701 L=1,MAXDO1
 7701 DCDY(L,J)=DCDY(L,J)*XYNOR

**    SUBSTRATE DOPING
      SUBS=ABS(C(MAXDO1,4)-C(MAXDO1,3))/CNOR

**    ASYMMETRIC SINGLE PROFILE SLICE DRAIN (5)
      IF (IPROF.EQ.2) THEN
         KK=5
      ELSE
         KK=1
      ENDIF

      DO 2 J=1,NY
**    CHANNEL PROFILE
      YY=Y(J+JY)
      K=INT(YY/YINC)+1
      IF (K.LT.MAXDO1) THEN
         Y1=YINC*(K-1)
         DOCA=CUBF(YY-Y1,YINC,C(K,3),DCDY(K,3))
         DOCD=CUBF(YY-Y1,YINC,C(K,4),DCDY(K,4))
         YH=MAX(ZERO,Y(J+JY)-YOFF)**2
      ELSE
         DOCA=C(MAXDO1,3)
         DOCD=C(MAXDO1,4)
         YH=(YINC*(MAXDO1-1))**2
      ENDIF

      DO 2 I=1,NX
      DOSA=0
      DOSD=0
**    SECOND SOURCE PROFILE
      IF (IPROF.EQ.4) THEN
**       LDD-DEVICE
         YY=SQRT(YH+MAX(ZERO,(X(I)+XOFF)/FITL)**2)
         K=INT(YY/YINC)+1
         IF (K.LT.MAXDO1) THEN
            Y1=YINC*(K-1)
            DOSA=DOSA+CUBF(YY-Y1,YINC,C(K,5),DCDY(K,5))
            DOSD=DOSD+CUBF(YY-Y1,YINC,C(K,6),DCDY(K,6))
         ELSE
            DOSA=DOSA+C(MAXDO1,5)
            DOSD=DOSD+C(MAXDO1,6)
         ENDIF
      ENDIF
**    SOURCE PROFILE
      YY=SQRT(YH+MAX(ZERO,X(I)/FITL)**2)
      K=INT(YY/YINC)+1
      IF (K.LT.MAXDO1) THEN
         Y1=YINC*(K-1)
         DOSA=DOSA+CUBF(YY-Y1,YINC,C(K,1),DCDY(K,1))
         DOSD=DOSD+CUBF(YY-Y1,YINC,C(K,2),DCDY(K,2))
      ELSE
         DOSA=DOSA+C(MAXDO1,1)
         DOSD=DOSD+C(MAXDO1,2)
      ENDIF
**    DRAIN PROFILE
      YY=SQRT(YH+MAX(ZERO,(XLPRO1-X(I))/FITL)**2)
      K=INT(YY/YINC)+1
      IF (K.LT.MAXDO1) THEN
         Y1=YINC*(K-1)
         DOSA=DOSA+CUBF(YY-Y1,YINC,C(K,KK),DCDY(K,KK))
         DOSD=DOSD+CUBF(YY-Y1,YINC,C(K,KK+1),DCDY(K,KK+1))
      ELSE
         DOSA=DOSA+C(MAXDO1,KK)
         DOSD=DOSD+C(MAXDO1,KK+1)
      ENDIF
**    SECOND DRAIN PROFILE
      IF (IPROF.EQ.4.OR.IPROF.EQ.6) THEN
**       TWO SLICES FOR DRAIN
         YY=SQRT(YH+MAX(ZERO,(XLPRO2-X(I))/FITL)**2)
         K=INT(YY/YINC)+1
         IF (K.LT.MAXDO1) THEN
            Y1=YINC*(K-1)
            DOSA=DOSA+CUBF(YY-Y1,YINC,C(K,5),DCDY(K,5))
            DOSD=DOSD+CUBF(YY-Y1,YINC,C(K,6),DCDY(K,6))
         ELSE
            DOSA=DOSA+C(MAXDO1,5)
            DOSD=DOSD+C(MAXDO1,6)
         ENDIF
      ENDIF

**    ADD ALL COMPONENTS PROPERLY
      L=(J-1)*NX+I
      CACC(L)=(DOCA+DOSA)/CNOR
 2    CDON(L)=(DOCD+DOSD)/CNOR

**    CORRECT SUBSTRATE DOPING
      IF (IPROF.EQ.4) THEN
**       LDD-DEVICE
         CORREC=4
      ELSEIF (IPROF.EQ.6) THEN
**       ASYMMETRIC LDD-DEVICE
         CORREC=3
      ELSE
         CORREC=2
      ENDIF
      CORREC=CORREC*SUBS
      IF (ICHANL.GT.0) THEN
         DO 7702 L=1,NXY
 7702    CACC(L)=CACC(L)-CORREC
      ELSE
         DO 7703 L=1,NXY
 7703    CDON(L)=CDON(L)-CORREC
      ENDIF
      RETURN

**    DOPING FILE EMPTY
 3    CALL ABTMOS (4)

**    INSUFFICIENT DATA ON DOPING FILE
 4    CALL ABTMOS (5)

      END
