      SUBROUTINE BERCO (PSI,DPSI,H1,H2,H3,TCMIN,TCMAJ,NKIND)
      INCLUDE 'TYPES.INC'

***   BERCO - BERNOULLI COEFFICIENTS
*
*     S.SELBERHERR   1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      DIMENSION PSI(NXT),DPSI(NXT),H1(NXT),H2(NXT),H3(NXT),TCMIN(NXT),
     1TCMAJ(NXT)

**    START OF EXECUTABLE CODE
*     ************************
*
      IF (ITC(1).NE.JSLPRE) CALL SLTGET (TCMIN,ITC(1),NXT)
      IF (ITC(2).NE.JSLPRE) CALL SLTGET (TCMAJ,ITC(2),NXT)

      NOFF=1
      DO 3 IDIR=1,2
      NEC=NXT-NOFF
      DO 7701 L=1,NEC
 7701 DPSI(L)=PSI(L+NOFF)-PSI(L)
      IF (ITC(1).NE.JSLPRE) THEN
         DO 1 L=1,NEC
         H=TCMIN(L+NOFF)-TCMIN(L)
         IF (ABS(H).GT.EPSMA) THEN
            HH=LOG(TCMIN(L+NOFF)/TCMIN(L))/H
         ELSE
            HH=(3-TCMIN(L+NOFF)/TCMIN(L))/(2*TCMIN(L))
         ENDIF
         H1(L)=HH*(DPSI(L)-H)
 1       H3(L)=HH
      ELSE
         DO 7702 L=1,NEC
 7702    H1(L)=DPSI(L)
      ENDIF
      CALL BERFUN (H1,H2,NEC)
      IF (ITC(1).NE.JSLPRE) THEN
         DO 7703 L=1,NEC
         H=2/((TCMIN(L+NOFF)+TCMIN(L))*H3(L))
         H1(L)=H*H1(L)
 7703    H2(L)=H*H2(L)
      ENDIF
      CALL SLTPUT (H1,IBEP(2*IDIR-1),NEC)
      CALL SLTPUT (H2,IBEB(2*IDIR-1),NEC)

      IF (NKIND.EQ.2) THEN
         IF (ITC(2).NE.JSLPRE) THEN
            DO 2 L=1,NEC
            H=TCMAJ(L+NOFF)-TCMAJ(L)
            IF (ABS(H).GT.EPSMA) THEN
               HH=LOG(TCMAJ(L+NOFF)/TCMAJ(L))/H
            ELSE
               HH=(3-TCMAJ(L+NOFF)/TCMAJ(L))/(2*TCMAJ(L))
            ENDIF
            H1(L)=-HH*(DPSI(L)+H)
 2          H3(L)=HH
            CALL BERFUN (H1,H2,NEC)
            DO 7704 L=1,NEC
            H=2/((TCMAJ(L+NOFF)+TCMAJ(L))*H3(L))
            H1(L)=H*H1(L)
 7704       H2(L)=H*H2(L)
            IF (IBEP(2*IDIR).EQ.IBEB(2*IDIR-1)) IBEP(2*IDIR)=JSLPRE
            CALL SLTPUT (H1,IBEP(2*IDIR),NEC)
            IF (IBEB(2*IDIR).EQ.IBEP(2*IDIR-1)) IBEB(2*IDIR)=JSLPRE
            CALL SLTPUT (H2,IBEB(2*IDIR),NEC)
         ELSE
            IBEP(2*IDIR)=IBEB(2*IDIR-1)
            IBEB(2*IDIR)=IBEP(2*IDIR-1)
         ENDIF
      ENDIF

 3    NOFF=NX

      END
      SUBROUTINE BERFUN (X,A,N)
      INCLUDE 'TYPES.INC'

***   BERFUN - CALCULATE BERNOULLI FUNCTION
*
*     S.SELBERHERR   1979-1986
*
      PARAMETER (P0=1,P1=P0/2,P2=P0/12,P3=P0/720,P4=P0/30240)
      INCLUDE 'CMSYSX.INC'
      DIMENSION X(N),A(N)

**    START OF EXECUTABLE CODE
*     ************************
*
      DO 1 I=1,N
      Y=ABS(X(I))
      IF (Y.GE.EXPLIM) THEN
         F=0
      ELSEIF (Y.GE.BERMIN) THEN
         F=EXP(-Y)
         F=Y*F/(1-F)
      ELSE
         F=1-Y*(P1-Y*(P2-Y*Y*(P3-Y*Y*P4)))
      ENDIF
      Y=X(I)
      IF (Y.GE.0) THEN
         X(I)=F
         A(I)=F+Y
      ELSE
         X(I)=F-Y
         A(I)=F
      ENDIF
 1    CONTINUE

      END
      SUBROUTINE CCNET (CNET,CDON,CACC)
      INCLUDE 'TYPES.INC'

***   CCNET - COMPUTE NET DOPING CONCENTRATION
*
*     S.SELBERHERR   1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      DIMENSION CNET(NXY),CDON(NXY),CACC(NXY)

**    START OF EXECUTABLE CODE
*     ************************
*
      IF (ICHANL.GT.0) THEN
         DO 7701 L=1,NXY
 7701    CNET(L)=CDON(L)-CACC(L)
      ELSE
         DO 7702 L=1,NXY
 7702    CNET(L)=CACC(L)-CDON(L)
      ENDIF
      DO 1 L=1,NXY
 1    IF (ABS(CNET(L)).LT.CINTR) CNET(L)=CINTR

      END
      SUBROUTINE COEPOI (E,A,C,H)
      INCLUDE 'TYPES.INC'

***   COEPOI - COMPUTE REDUNDANT COEFFICIENTS FOR
*              POISSON EQUATION
*
*     S.SELBERHERR   1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      DIMENSION E(NXYTOT),A(NXYTOT),C(NXYTOT),H(NXYTOT)

**    START OF EXECUTABLE CODE
*     ************************
*
*     SUB/SUP DIAGONAL
      H1=EINS/ESEM
      DO 1 J=1,NYOX-1
      JJ=(J-1)*NX
      DO 1 L=1,NX-1
 1    A(L+JJ)=H1*DYM(J)/DX(L)
      JJ=JJ+NX
      DO 7701 L=1,NX-1
 7701 A(L+JJ)=(H1*DY(NYOX-1)+DY(NYOX))/DX(L)
      DO 2 J=NYOX+1,NYSEM-1
      JJ=(J-1)*NX
      DO 2 L=1,NX-1
 2    A(L+JJ)=DYM(J)/DX(L)
      JJ=JJ+NX
      IF (LBOTI) THEN
         H2=EISUBS/ESEM
         DO 7702 L=1,NX-1
 7702    A(L+JJ)=(DY(NYSEM-1)+H2*DY(NYSEM))/DX(L)
         DO 3 J=NYSEM+1,NYTOT
         JJ=(J-1)*NX
         DO 3 L=1,NX-1
 3       A(L+JJ)=H2*DYM(J)/DX(L)
      ELSE
         DO 7703 L=1,NX-1
 7703    A(L+JJ)=DY(NYTOT-1)/DX(L)
      ENDIF
      DO 7704 L=1,NYTOT
 7704 A(L*NX)=0

**    SUPER-SUB/SUPER-SUP DIAGONAL
      DO 4 J=1,NYOX-1
      JJ=(J-1)*NX
      DO 4 L=1,NX
 4    C(L+JJ)=H1*DXM(L)/DY(J)
      DO 5 J=NYOX,NYSEM-1
      JJ=(J-1)*NX
      DO 5 L=1,NX
 5    C(L+JJ)=DXM(L)/DY(J)
      DO 6 J=NYSEM,NYTOT-1
      JJ=(J-1)*NX
      DO 6 L=1,NX
 6    C(L+JJ)=H2*DXM(L)/DY(J)
      JJ=JJ+NX
      DO 7705 L=1,NX
 7705 C(L+JJ)=0

**    MAIN DIAGONAL
      E(1)=-A(1)-C(1)
      DO 7706 L=2,NX
 7706 E(L)=-A(L)-A(L-1)-C(L)
      DO 7707 L=NX+1,NXYTOT-NX
 7707 E(L)=-A(L)-A(L-1)-C(L)-C(L-NX)
      DO 7708 L=NXYTOT-NX+1,NXYTOT-1
 7708 E(L)=-A(L)-A(L-1)-C(L-NX)
      E(NXYTOT)=-A(NXYTOT-1)-C(NXYTOT-NX)

**    DISCRETIZATION AREAS
      DO 7 J=1,NYSEM
      JJ=(J-1)*NX
      DO 7 L=1,NX
 7    H(L+JJ)=DYM(J)*DXM(L)/2

**    SAVE ALL COEFFICIENTS
      CALL SLTPUT (A,IPOI(1),NXYTOT)
      CALL SLTPUT (C,IPOI(2),NXYTOT)
      CALL SLTPUT (E,IPOI(3),NXYTOT)
      CALL SLTPUT (H,IPOI(4),NXYOX+NXY)

      END
      SUBROUTINE FIMILE
      INCLUDE 'TYPES.INC'

***   FIMILE - FIND MILESTONES IN MESH
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'

**    COMPUTE MESH POINTERS
*
*     SEARCH IN X-DIRECTION
*
*     FIND X(I=NXS)=-XOFF-SGAP
      CALL FIMILH (-XOFF-SGAP,X,NX,NXS)
**    FIND X(I=NXG1)=0
      CALL FIMILH (ZERO,X(1+NXS),NX-NXS,NXG1)
      NXG1=NXG1+NXS
**    FIND X(I=NXG2)=XLGEO
      CALL FIMILH (XLGEO,X(1+NXG1),NX-NXG1,NXG2)
      NXG2=NXG2+NXG1
**    FIND X(I=NXD)=XLGEO+XOFF+DGAP
      CALL FIMILH (XLGEO+XOFF+DGAP,X(1+NXG2),NX-NXG2,NXD)
      NXD=NXD+NXG2

**    SEARCH IN Y-DIRECTION
*
*     FIND Y(J=NYG)=-TINS
      CALL FIMILH (-TINS,Y,NYTOT,NYG)
**    FIND Y(J=NYOX)=0
      CALL FIMILH (ZERO,Y(1+NYG),NYTOT-NYG,NYOX)
      NYOX=NYOX+NYG
**    FIND Y(J=NYSEM)=YSEMI
      IF (LBOTI) THEN
         CALL FIMILH (YSEMI,Y(1+NYOX),NYTOT-NYOX,NYSEM)
         NYSEM=NYSEM+NYOX
      ELSE
         NYSEM=NYTOT
      ENDIF

**    COMPUTE AUXILIARY MESH POINTERS
*
*     FOR Y-DIRECTION
      NY=NYSEM-(NYOX-1)

**    FOR X-Y PRODUCTS
      NXYOX=NX*(NYOX-1)
      NXY=NX*NY
      NXYMX=NXY-NX
      IF (LBOTI) THEN
         NXYB=NXY
      ELSE
         NXYB=NXYMX
      ENDIF
      NXYSEM=NX*NYSEM
      NXYTOT=NX*NYTOT

**    COMPUTE AUXILIARY MESH PARAMETERS
*
*     FOR X-MESH
      DXM(1)=DX(1)
      DO 7701 L=1,NX-2
 7701 DXM(L+1)=DX(L)+DX(L+1)
      DXM(NX)=DX(NX-1)

**    FOR Y-MESH
      DYM(1)=DY(1)
      DO 7702 L=1,NYTOT-2
 7702 DYM(L+1)=DY(L)+DY(L+1)
      DYM(NYTOT)=DY(NYTOT-1)
**    BE AWARE OF THE INTERFACE(S)
      DYM(NYOX)=DY(NYOX)
      IF (LBOTI) DYM(NYSEM)=DY(NYSEM-1)

      END
      SUBROUTINE FIMILH (ZDESIR,Z,NZ,KDESIR)
      INCLUDE 'TYPES.INC'

***   FIMILH - AUXILIARY ROUTINE TO FIND MILESTONES IN A MESH
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      DIMENSION Z(NZ)

**    COMPUTE LOWER AND UPPER LIMIT FOR MATCH CRITERION
      ZLOW=ZDESIR*(1-SIGN(EPSMA,ZDESIR))
      ZHIG=ZDESIR*(1+SIGN(EPSMA,ZDESIR))
**    SEARCH SEQUENTIALLY FOR MATCH
      DO 1 K=1,NZ
      IF (ZLOW.LE.Z(K).AND.Z(K).LE.ZHIG) GOTO 2
 1    CONTINUE
**    NO MATCH IS FATAL AND NON-RECOVERABLE
      CALL ABTMOS (0)

**    RETURN THE DESIRED INDEX
 2    KDESIR=K

      END
      SUBROUTINE MEMRY
      INCLUDE 'TYPES.INC'

***   MEMRY - *MINIMOS* MEMORY MANAGER
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
      JP(1)=1
      DO 1 I=2,MAXPAD
 1    JP(I)=JP(I-1)+NXYTOT

      END
      SUBROUTINE MOBIL (PSI,CC,CTOT,A1,A2,A3,A4,A5,A6,A7,NKIND)
      INCLUDE 'TYPES.INC'

***   MOBIL - ESTIMATE CARRIER DIFFUSIVITY DISTRIBUTIONS
*
*     S.SELBERHERR   1979-1986
*
      PARAMETER (FPER=0.97)
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      DIMENSION PSI(NXT),CC(NXT),CTOT(NXT),A1(NXT),A2(NXT),A3(NXT),
     1A4(NXT),A5(NXT),A6(NXT),A7(NXT),PTC(2),RMU0(2),RM0EXP(2),
     2RMUMIN(2),RMUREF(2),RMMEXP(2),DOPCO(2),DOPEXP(2),WEXP(2),
     3WEXEXP(2),VSATC(2),VSAREF(2),DREF(2),EREF(2),SUREXP(2),TOTEXP(2),
     4C1MOBE(2),C1MOBI(2),C1MOBS(2),C1MOBT(2),C2MOBI(2),C2MOBS(2),
     5C3MOBS(2),C4MOBS(2),CMOBL(2),CMOBLI(2),RMUEXP(2),RTECR(2),
     6CTECR(2)

**    MOBILITY CONSTANTS
      DATA RMU0   /1430.,460./
      DATA RMUMIN /  80., 45./
      DATA RMUREF / 638.,160./

      DATA DOPCO  /1.12E+17,2.23E+17/
      DATA VSATC  /1.45E+07,9.05E+06/
      DATA VSAREF /1.55E+02,3.12E+02/
      DATA DREF   /1.00E-06,1.00E-06/
      DATA EREF   /7.00E+05,2.70E+05/

      DATA RM0EXP /-2.00,-2.18/
      DATA RMMEXP /-0.45,-0.45/
      DATA RMUEXP /-1.19,-1.09/
      DATA DOPEXP / 3.20, 3.20/
      DATA WEXP   / 0.72, 0.72/
      DATA WEXEXP / 0.065,0.065/
      DATA SUREXP / 1.30, 1.00/
      DATA TOTEXP / 2.00, 1.00/

      DATA RTECR /1.0E14,1.0E14/

**    START OF EXECUTABLE CODE
*     ************************
*
*     MOBILITY PARAMETERS
      INDXN=(3-ICHANL)/2
      INDXP=(3+ICHANL)/2
      IKIND=INDXN
      T=SIMTEM/300
      H=UT/XYNOR**2
      DO 1 JKIND=1,2
*     PARAMETER                     TEMPERATURE        USER     SCALING
      CMOBL (IKIND)=RMU0  (JKIND)  *T**RM0EXP(JKIND)  *WML     *H
      IF (SIMTEM.GE.200) THEN
         CMOBLI(IKIND)=RMUMIN(JKIND)*T**RMMEXP(JKIND)          *H
      ELSE
         CMOBLI(IKIND)=RMUMIN(JKIND)*(200./300.)**RMMEXP(JKIND)*
     1                               (SIMTEM/200)**(-0.15)    *H
      ENDIF
      C1MOBI(IKIND)=DOPCO (JKIND)  *T**DOPEXP(JKIND)  *WMI     /CNOR
      C2MOBI(IKIND)=WEXP  (JKIND)  *T**WEXEXP(JKIND)
      H1=EXP(-VSAREF(JKIND)/SIMTEM)
      H1=SQRT((1-H1*H1)/(1+H1*H1))
      C1MOBE(IKIND)=VSATC (JKIND)  *H1                *WMV     /XYNOR
      C1MOBS(IKIND)=RMUREF(JKIND)  *T**RMUEXP(JKIND)  *WMR     *H
      C2MOBS(IKIND)=DREF  (JKIND)                     /WMS     /XYNOR
      C3MOBS(IKIND)=EREF  (JKIND)                     *WMT     *XYNOR/UT
      C4MOBS(IKIND)=SUREXP(JKIND)
      C1MOBT(IKIND)=TOTEXP(JKIND)                     *WMB
*     REFERENCE CONCENTRATION FOR ENERGY RELAXATION
      CTECR(IKIND)=RTECR(JKIND)                              /CNOR
 1    IKIND=INDXP

**    TOTAL IMPURITY CONCENTRATION
      CALL SLTGET (CTOT,ICDON,NXT)
      CALL SLTGET (CC,ICACC,NXT)
      DO 7701 L=1,NXT
 7701 CTOT(L)=CTOT(L)+CC(L)

**    MAXIMUM DRIVING FORCE (SQUARED)
      FMAX2=(1E6*XYNOR/UT)**2

**    LOOP OVER CARRIER TYPES
      DO 17 KIND=1,NKIND
*     QUANTITIES FOR OUTPUT
      VSAT(KIND)=C1MOBE(KIND)*XYNOR
      ZMOB(KIND)=CMOBL(KIND)*XYNOR**2/UT
      CALL SLTGET (CC,ICC(KIND),NXT)
      IF (ITC(KIND).EQ.JSLPRE) THEN
**       STILL NO CARRIER TEMPERATURES
         IF (KIND.EQ.1) THEN
            DO 7702 L=1,NXT
 7702       A6(L)=LOG(CC(L))-PSI(L)
         ELSE
            DO 7703 L=1,NXT
 7703       A6(L)=LOG(CC(L))+PSI(L)
         ENDIF
         CALL DIFFX (A3,A6,DX,NX,NT)
         CALL DIFFY (A4,A6,DY(NYOX),NX,NT)
      ELSE
         CALL SLTGET (A7,ITC(KIND),NXT)
         DO 7704 L=1,NXT
 7704    A5(L)=LOG(CC(L))
         IF (KIND.EQ.1) THEN
            DO 7705 L=1,NXT
 7705       A6(L)=A7(L)-PSI(L)
         ELSE
            DO 7706 L=1,NXT
 7706       A6(L)=A7(L)+PSI(L)
         ENDIF
         CALL DIFFX (A3,A5,DX,NX,NT)
         CALL DIFFY (A4,A5,DY(NYOX),NX,NT)
         CALL DIFFX (A1,A6,DX,NX,NT)
         CALL DIFFY (A2,A6,DY(NYOX),NX,NT)
         DO 2 L=1,NXT-1
 2       A3(L)=A3(L)*(A7(L)+A7(L+1))/2+A1(L)
         DO 3 L=1,NXTMX
 3       A4(L)=A4(L)*(A7(L)+A7(L+NX))/2+A2(L)
      ENDIF

**    INTERPOLATE TO POINT VALUES
      CALL INTERX (A5,A3,NX,NT,0)
      CALL INTERY (A6,A4,NX,NT,0)
      DO 4 L=1,NXT
      IF (CTOT(L).LT.1E19/CNOR) THEN
         A6(L)=MIN(FMAX2,A6(L)**2+A5(L)**2)
      ELSE
         A6(L)=0
      ENDIF
 4    CONTINUE

**    TRANSVERSAL DERIVATIVE OF ELECTROSTATIC POTENTIAL
      CALL DIFFY (A5,PSI,DY(NYOX),NX,NT)
      CALL INTERY (A2,A5,NX,NT,3)

**    NOW MERGE THE VARIOUS SCATTERING EFFECTS
*
*     IONIZED IMPURITY SCATTERING
      H1=CMOBLI(KIND)
      H2=CMOBL(KIND)-CMOBLI(KIND)
      H3=1/C1MOBI(KIND)
      H4=C2MOBI(KIND)
      DO 7707 L=1,NXT
 7707 A5(L)=H1+H2/(1+(CTOT(L)*H3)**H4)

**    SURFACE SCATTERING
      H1=C1MOBS(KIND)
      H2=1/C2MOBS(KIND)
      IF (KIND.EQ.1) THEN
         H3=-1/C3MOBS(KIND)
      ELSE
         H3=1/C3MOBS(KIND)
      ENDIF
      H4=C4MOBS(KIND)
      IF (H4.EQ.1) THEN
         DO 5 J=1,NT
         JJ=(J-1)*NX
         FY=(Y(J+NYOX-1)*H2)**2
         IF (FY.GE.EXPLIM) GOTO 8
         FY=EXP(-FY)
         FY=2*FY/(1+FY**2)
         DO 5 L=JJ+1,JJ+NX
 5       A3(L)=(H1+(A5(L)-H1)*(1-FY))/(1+FY*MAX(ZERO,A2(L)*H3))
      ELSEIF (H4.EQ.2) THEN
         DO 6 J=1,NT
         JJ=(J-1)*NX
         FY=(Y(J+NYOX-1)*H2)**2
         IF (FY.GE.EXPLIM) GOTO 8
         FY=EXP(-FY)
         FY=2*FY/(1+FY**2)
         DO 6 L=JJ+1,JJ+NX
 6       A3(L)=(H1+(A5(L)-H1)*(1-FY))/(1+FY*MAX(ZERO,A2(L)*H3)**2)
      ELSE
         DO 7 J=1,NT
         JJ=(J-1)*NX
         FY=(Y(J+NYOX-1)*H2)**2
         IF (FY.GE.EXPLIM) GOTO 8
         FY=EXP(-FY)
         FY=2*FY/(1+FY**2)
         DO 7 L=JJ+1,JJ+NX
 7       A3(L)=(H1+(A5(L)-H1)*(1-FY))/(1+FY*MAX(ZERO,A2(L)*H3)**H4)
      ENDIF
      JJ=JJ+NX
 8    DO 7708 L=1,JJ
 7708 A5(L)=MIN(A5(L),A3(L))

**    BACK INTERFACE SURFACE SCATTERING
      IF (LBOTI) THEN
         H3=-H3
         IF (H4.EQ.1) THEN
            DO 9 J=NT,1,-1
            JJ=(J-1)*NX
            FY=((YSEMI-Y(J+NYOX-1))*H2)**2
            IF (FY.GE.EXPLIM) GOTO 12
            FY=EXP(-FY)
            FY=2*FY/(1+FY**2)
            DO 9 L=JJ+1,JJ+NX
 9          A3(L)=(H1+(A5(L)-H1)*(1-FY))/(1+FY*MAX(ZERO,A2(L)*H3))
         ELSEIF (H4.EQ.2) THEN
            DO 10 J=NT,1,-1
            JJ=(J-1)*NX
            FY=((YSEMI-Y(J+NYOX-1))*H2)**2
            IF (FY.GE.EXPLIM) GOTO 12
            FY=EXP(-FY)
            FY=2*FY/(1+FY**2)
            DO 10 L=JJ+1,JJ+NX
 10         A3(L)=(H1+(A5(L)-H1)*(1-FY))/(1+FY*MAX(ZERO,A2(L)*H3)**2)
         ELSE
            DO 11 J=NT,1,-1
            JJ=(J-1)*NX
            FY=((YSEMI-Y(J+NYOX-1))*H2)**2
            IF (FY.GE.EXPLIM) GOTO 12
            FY=EXP(-FY)
            FY=2*FY/(1+FY**2)
            DO 11 L=JJ+1,JJ+NX
 11        A3(L)=(H1+(A5(L)-H1)*(1-FY))/(1+FY*MAX(ZERO,A2(L)*H3)**H4)
         ENDIF
         JJ=JJ-NX
 12      DO 7709 L=JJ+NX+1,NXT
 7709    A5(L)=MIN(A5(L),A3(L))
      ENDIF

**    VELOCITY SATURATION
      H1=1/C1MOBE(KIND)
      H2=C1MOBT(KIND)
      IF (H2.EQ.1) THEN
         FMINSQ=((1/FPER-1)/H1)**2
         DO 13 L=1,NXT
         IF (A6(L).GT.FMINSQ/A5(L)**2) THEN
            A3(L)=A5(L)/(1+A5(L)*SQRT(A6(L))*H1)
         ELSE
            A3(L)=A5(L)
         ENDIF
 13      CONTINUE
      ELSEIF (H2.EQ.2) THEN
         FMINSQ=((2/FPER-1)**2-1)/(2*H1)**2
         DO 14 L=1,NXT
         IF (A6(L).GT.FMINSQ/A5(L)**2) THEN
            A3(L)=2*A5(L)/(1+SQRT(1+(2*A5(L)*H1)**2*A6(L)))
         ELSE
            A3(L)=A5(L)
         ENDIF
 14      CONTINUE
      ELSE
         H3=1/H2
         FMINSQ=(((2/FPER-1)**H2-1)**H3/(2*H1))**2
         DO 15 L=1,NXT
         IF (A6(L).GT.FMINSQ/A5(L)**2) THEN
            A3(L)=2*A5(L)/(1+(1+(2*A5(L)*SQRT(A6(L))*H1)**H2)**H3)
         ELSE
            A3(L)=A5(L)
         ENDIF
 15      CONTINUE
      ENDIF

**    IF CARRIER TEMPERATURE HAS TO BE ADJUSTED
      IF (IMODEL.EQ.5) THEN
         TAUEN(KIND)=1.5*UTP(KIND)*UT*ZMOB(KIND)/VSAT(KIND)**2
         H1=UTP(KIND)
**       NO CARRIER HEATING IF DOPING CONCENTRATION .GE. 1E19
         H2=1E19/CNOR
**       MODEL RELAXATION TIME CARRIER CONCENTRATION DEPENDENT
         CALL SLTGET (A2,ICC(3-KIND),NXT)
         DO 16 L=1,NXT
         H1=UTP(KIND)*A5(L)/CMOBL(KIND)
         IF (CTOT(L).LT.H2) THEN
            A5(L)=1+H1/(1+A2(L)/CTECR(KIND))*(A5(L)-A3(L))/A3(L)
         ELSE
            A5(L)=1
         ENDIF
 16      CONTINUE
         DO 7710 L=1,NXS
 7710    A5(L)=1
         DO 7711 L=NXD,NX
 7711    A5(L)=1
         DO 7712 L=NXT+1,NXY
 7712    A5(L)=1
         CALL SLTPUT (A5,ITC(KIND),NXT)
         IF (ICC(KIND+2).EQ.JSLPRE) THEN
            PTC(KIND)=1
         ELSE
            CALL SLTGET (A2,ICC(KIND+2),NXT)
            PTC(KIND)=DIFNRM(CC,A2,NXT)
         ENDIF
         CALL SLTPUT (CC,ICC(KIND+2),NXT)
         DO 7713 L=1,NXT
 7713    A3(L)=A3(L)*A5(L)
      ELSEIF (ITC(KIND).NE.JSLPRE) THEN
         CALL SLTGET (A5,ITC(KIND),NXT)
         DO 7714 L=1,NXT
 7714    A3(L)=A3(L)*A5(L)
      ENDIF
**    SAVE DIFFUSIVITY DISTRIBUTION
 17   CALL SLTPUT (A3,IDIF(KIND),NXT)

      IF (IMODEL.LE.2) THEN
         DO 18 L=1,NX+NT-2
 18      A7(L)=0
         IF (MODEL.EQ.5) THEN
**          ESTIMATE MINORITY CARRIER TEMPERATURE FOR MESHING
*           NO CARRIER HEATING IF DOPING CONCENTRATION .GE. 1E19
            H1=1E19/CNOR
            DO 19 L=1,NXT
            IF (CTOT(L).LT.H1) THEN
               A5(L)=A5(L)/CMOBL(1)*(A5(L)-A3(L))/A3(L)
            ELSE
               A5(L)=0
            ENDIF
 19         CONTINUE
**          LATERAL DIFFERENCES
            DO 20 J=1,NT
            JJ=(J-1)*NX
            DO 20 L=JJ+1,JJ+NX-1
 20         A7(L-JJ)=MAX(A7(L-JJ),ABS(A5(L+1)-A5(L)))
**          VERTICAL DIFFERENCES
            DO 21 J=1,NT-1
            JJ=(J-1)*NX
            DO 21 L=JJ+1,JJ+NX
 21         A7(J+NX-1)=MAX(A7(J+NX-1),ABS(A5(L+NX)-A5(L)))
            DO 22 L=1,NX+NT-2
 22         A7(L)=5*UTP(1)*A7(L)
         ENDIF
      ELSEIF (IMODEL.EQ.5) THEN
         WRITE(NUMREF,'(11X,''CARRIER TEMPERATURE UPDATE'')')
         PNORH=MAX(PTC(1),PTC(2))
         WRITE (NUMREF,'(11X,I4,1P2E9.1)') ITHOT,PTC(2),PTC(1)
      ENDIF

      END
      SUBROUTINE THRES (OLDI,LUTHOK)
      INCLUDE 'TYPES.INC'

***   THRES - CALCULATE THRESHOLD VOLTAGE
*
*     A.SCHUETZ      1980-1983
*     S.SELBERHERR   1979-1986
*
      PARAMETER (SLPMIN=1.E-4)
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      SAVE OLDU

**    START OF EXECUTABLE CODE
*     ************************
*
      IF (OLDI.EQ.0) THEN
**       FOR THE FIRST TIME
         OLDU=UG
         OLDI=FLUXD(1)
         H=SIGN(0.5/UT,THCUR-FLUXD(1))
      ELSE
         IF (FLUXD(1).LE.THCUR) THEN
**          LOGARITHMIC CHARACTERISTIC
            CRELR=LOG(THCUR)
            CRELO=LOG(ABS(OLDI))
            CRELN=LOG(ABS(FLUXD(1)))
         ELSE
**          PARABOLIC CHARACTERISTIC
            CRELR=SQRT(THCUR)
            CRELO=SQRT(ABS(OLDI))
            CRELN=SQRT(ABS(FLUXD(1)))
         ENDIF
**       KIND OF REGULA FALSI
         H=(UG-OLDU)*(CRELR-CRELN)
         IF (ABS(H)*UT.LT.ABS(CRELN-CRELO)) THEN
            H=H/(CRELN-CRELO)
         ELSE
            H=SIGN(1/UT,H*(CRELN-CRELO))
         ENDIF
**       SHOULD NEVER BE NECESSARY
         IF (FLUXD(1).LT.THCUR.AND.H.LT.0) H=1/UT
**       IF WE SEEM TO DIVERGE ...
         IF (ABS(LOG(ABS(FLUXD(1)/OLDI))).LT.ABS(UG-OLDU)*SLPMIN
     1   .AND.H.LT.0.AND.LPHYCK) GOTO 1
**       MAKE SURE NOT TO OSZILLATE
         IF (ABS(OLDU-(UG+H)).LE.ABS(H)) H=H/2
         OLDI=FLUXD(1)
         OLDU=UG
      ENDIF
**    DID WE FIND THE THRESHOLD VOLTAGE?
      LUTHOK=(ABS(FLUXD(1)-THCUR).LE.ERROR*THCUR).OR.
     1ABS(H)*UT.LE.ERROR
      IF (.NOT.LUTHOK) THEN
         UG=UG+H
         UGS=UGS+H
      ENDIF
      GOTO 2

**    PULL EMERGENCY BREAK
 1    IFAIL=3
      LUTHOK=.TRUE.
 2    WRITE (NUMREF,'(/11X,''THRESHOLD VOLTAGE ='',F10.2,'' (V)'')')
     1(UG+US)*UT*ICHANL

      END
      SUBROUTINE WNRM
      INCLUDE 'TYPES.INC'

***   WNRM - COMPUTE WEIGHT FUNCTION FOR CURRENT INTEGRATION
*
*     S.SELBERHERR   1987
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'

      WEIG1(U,V)=(U-V)*(1-16*(U**2+U*V+V**2)/27)
      WEIG2(U,V)=(U-V)/(4*C)*(1+(U+V)*(1-8*(U**2+V**2)/27))
      WEIGI(Z)=C*(A+B-2*MAX(A,MIN(Z,B)))

**    START OF EXECUTABLE CODE
*     ************************
*
      A=X(NXS+1)
      B=X(NXD-1)
      C=3/(4*(B-A))

      H2=X(1)-(X(2)-X(1))/2
      DO 1 I=1,NX-1
      H1=H2
      H2=(X(I)+X(I+1))/2
      XA=DIM(A,H2)-DIM(A,H1)
 1    FWX(I)=WEIG2(WEIGI(H2),WEIGI(H1))+XA
      H1=H2
      H2=X(NX)+(X(NX)-X(NX-1))/2
      FWX(NX)=WEIG2(WEIGI(H2),WEIGI(H1))

      H2=WEIGI(X(1))
      DO 2 I=1,NX-1
      H1=H2
      H2=WEIGI(X(I+1))
 2    DFWX(I)=WEIG1(H2,H1)

      A=Y(NYOX)
      B=Y(NYOX+NY-1)
      C=3/(4*(B-A))

      H2=WEIGI(Y(NYOX))
      DO 3 J=1,NY-1
      H1=H2
      H2=WEIGI((Y(J+NYOX-1)+Y(J+NYOX))/2)
 3    FWY(J)=WEIG2(H1,H2)
      H1=H2
      H2=Y(NY+NYOX-1)
      IF (.NOT.LBOTI) H2=2*H2-H1
      FWY(NY)=WEIG2(H1,WEIGI(H2))

      H2=WEIGI(Y(NYOX))
      DO 4 J=1,NY-1
      H1=H2
      H2=WEIGI(Y(J+NYOX))
 4    DFWY(J)=WEIG1(H2,H1)

      END
